<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SupportCaseSolutions StructType
 * @subpackage Structs
 */
class SupportCaseSolutions extends AbstractStructBase
{
    /**
     * The solution
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RecordRef
     */
    public $solution;
    /**
     * The message
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $message;
    /**
     * The dateApplied
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dateApplied;
    /**
     * Constructor method for SupportCaseSolutions
     * @uses SupportCaseSolutions::setSolution()
     * @uses SupportCaseSolutions::setMessage()
     * @uses SupportCaseSolutions::setDateApplied()
     * @param \StructType\RecordRef $solution
     * @param string $message
     * @param string $dateApplied
     */
    public function __construct(\StructType\RecordRef $solution = null, $message = null, $dateApplied = null)
    {
        $this
            ->setSolution($solution)
            ->setMessage($message)
            ->setDateApplied($dateApplied);
    }
    /**
     * Get solution value
     * @return \StructType\RecordRef|null
     */
    public function getSolution()
    {
        return $this->solution;
    }
    /**
     * Set solution value
     * @param \StructType\RecordRef $solution
     * @return \StructType\SupportCaseSolutions
     */
    public function setSolution(\StructType\RecordRef $solution = null)
    {
        $this->solution = $solution;
        return $this;
    }
    /**
     * Get message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->message;
    }
    /**
     * Set message value
     * @param string $message
     * @return \StructType\SupportCaseSolutions
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        $this->message = $message;
        return $this;
    }
    /**
     * Get dateApplied value
     * @return string|null
     */
    public function getDateApplied()
    {
        return $this->dateApplied;
    }
    /**
     * Set dateApplied value
     * @param string $dateApplied
     * @return \StructType\SupportCaseSolutions
     */
    public function setDateApplied($dateApplied = null)
    {
        // validation for constraint: string
        if (!is_null($dateApplied) && !is_string($dateApplied)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateApplied, true), gettype($dateApplied)), __LINE__);
        }
        $this->dateApplied = $dateApplied;
        return $this;
    }
}
